package com.jeeplus.finance.ccpm.controller;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.extra.spring.SpringUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.jeeplus.finance.ccpm.service.ccpm.FlowRequest;
import com.jeeplus.finance.ccpm.vo.*;
import com.jeeplus.finance.contractRegistration.domain.ContractFilePaper;
import com.jeeplus.finance.contractRegistration.domain.ContractInfo;
import com.jeeplus.finance.contractRegistration.domain.ContractParticipant;
import com.jeeplus.finance.contractRegistration.mapper.ContractFilePaperMapper;
import com.jeeplus.finance.contractRegistration.mapper.ContractInfoMapper;
import com.jeeplus.finance.contractRegistration.mapper.ContractParticipantMapper;
import com.jeeplus.finance.projectDict.mapper.ProjectDictMapper;
import com.jeeplus.finance.projectRecords.domain.*;
import com.jeeplus.finance.projectRecords.mapper.*;
import com.jeeplus.finance.projectRecords.service.PartialCustomerInfoService;
import com.jeeplus.finance.projectRecords.service.dto.CwProjectClientInfoDTO;
import com.jeeplus.finance.projectRecords.service.dto.CwProjectRecordsDTO;
import com.jeeplus.finance.projectReport.domain.*;
import com.jeeplus.finance.projectReport.mapper.*;
import com.jeeplus.finance.utils.RestTemplateService;

import com.jeeplus.finance.workClientInfo.domain.CwWorkClientBase;
import com.jeeplus.finance.workClientInfo.domain.CwWorkClientBilling;
import com.jeeplus.finance.workClientInfo.domain.CwWorkClientContact;
import com.jeeplus.finance.workClientInfo.domain.CwWorkClientType;
import com.jeeplus.finance.workClientInfo.mapper.CwWorkClientBaseMapper;
import com.jeeplus.finance.workClientInfo.mapper.CwWorkClientBillingMapper;
import com.jeeplus.finance.workClientInfo.mapper.CwWorkClientContactMapper;
import com.jeeplus.finance.workClientInfo.mapper.CwWorkClientTypeMapper;
import com.jeeplus.finance.workClientInfo.service.dto.CwWorkClientBaseDTO;
import com.jeeplus.sys.domain.Area;
import com.jeeplus.sys.domain.WorkAttachmentInfo;
import com.jeeplus.sys.feign.*;


import com.jeeplus.sys.service.dto.OfficeDTO;
import com.jeeplus.sys.service.dto.UserDTO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.GetMapping;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.*;

@Component
public class CcpmList  {
    @Autowired
    private FlowRequest flowRequest;

    @Autowired
    private RestTemplateService restTemplateService;

    @Autowired
    private CwProjectRecordsMapper cwProjectRecordsMapper;

    @Autowired
    private CwProjectReviewNewMapper cwProjectReviewNewMapper;

    @Autowired
    private CwProjectReportMapper cwProjectReportMapper;

    @Autowired
    private CwProjectInfoMapper cwProjectInfoMapper;

    @Autowired
    private CwProjectReportSignAndIssueMapper cwProjectReportSignAndIssueMapper;

    @Autowired
    private CwProjectReportOnlineArchivingMapper cwProjectReportOnlineArchivingMapper;

    @Autowired
    private CwProjectReportPaperArchivingMapper cwProjectReportPaperArchivingMapper;

    @Autowired
    private ContractInfoMapper contractInfoMapper;

    @Autowired
    private CwWorkClientBaseMapper cwWorkClientBaseMapper;

    @Autowired
    private CwWorkClientBillingMapper cwWorkClientBillingMapper;

    @Autowired
    private CwWorkClientTypeMapper cwWorkClientTypeMapper;

    @Autowired
    private ContractFilePaperMapper contractFilePaperMapper;

    @Resource
    private CwWorkClientContactMapper cwWorkClientContactMapper;

    @Resource
    private CwProjectClientContactMapper cwProjectClientContactMapper;

    @Resource
    private CwProjectReviewNewTeamMapper newTeamMapper;

    @Resource
    private PartialCustomerInfoService customerInfoService;

    @Resource
    private CwProjectClientInfoMapper cwProjectClientInfoMapper;

    @Resource
    private ContractParticipantMapper contractParticipantMapper;

    @Resource
    private ProjectDictMapper projectDictMapper;

    @Resource
    private CwProjectMembersMapper cwProjectMembersMapper;

    @Resource
    private CwProjectPlanMapper cwProjectPlanMapper;




//    @PostConstruct
//    public void initMethod() throws Exception {
//        //获取所有的用户信息
//        List<UserDTO> allUserInfo = SpringUtil.getBean(IUserApi.class).getAllUserInfo();
//        getAllClient(allUserInfo);
//        getWorkContract(allUserInfo);
//        getProjectList(allUserInfo);
//    }

    public void getCcpmMethod() throws Exception {
        //获取所有的用户信息
        List<UserDTO> allUserInfo = SpringUtil.getBean(IUserApi.class).getAllUserInfo();
        getAllClient(allUserInfo);
        getWorkContract(allUserInfo);
        getProjectList(allUserInfo);
        getReviewNew(allUserInfo);
        getAllRuralProjectcontentinfo(allUserInfo);
    }

    /**
     * 获取质量复核信息
     * @param allUserInfo
     */
    @Transactional(rollbackFor = Exception.class, noRollbackFor = SQLException.class)
    public void getReviewNew(List<UserDTO> allUserInfo) {
        Object reviewNewList = flowRequest.getReviewNew();
        if(ObjectUtils.isNotEmpty(reviewNewList)) {
            List<RuralProjectRecordsVo> ruralProjectRecordsVos = JSONArray.parseArray(reviewNewList.toString(), RuralProjectRecordsVo.class);
            if (CollectionUtils.isNotEmpty(ruralProjectRecordsVos)){
                //先进行删除复核信息
//                cwProjectReviewNewMapper.deleteByTenantId();
                newTeamMapper.deleteByTenantId();
                for (RuralProjectRecordsVo recordsVo : ruralProjectRecordsVos) {
                    //获取报告号id
                    List<CwProjectReportData> report = cwProjectReportMapper.getByProjectId(recordsVo.getId());
                    CwProjectReportData reportInfo = null;
                    if (report.size()>0){
                        reportInfo = report.get(0);
                    }
                    //质量复核
                    if (StringUtils.isNotBlank(recordsVo.getPrdId())){
                        try {
                            // 复核
                            CwProjectReviewNew cwProjectReviewNew = new CwProjectReviewNew();
                            if (recordsVo.getProjectReportDataVo() != null) {
                                ProjectReportDataVo reportData = recordsVo.getProjectReportDataVo();
                                BeanUtils.copyProperties(reportData, cwProjectReviewNew);
                                // 设置创建和更新人
                                if (StringUtils.isNotBlank(recordsVo.getCreateName())) {
                                    UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(recordsVo.getCreateName());
                                    if (userDTO != null) {
                                        cwProjectReviewNew.setCreateById(userDTO.getId());
                                        cwProjectReviewNew.setUpdateById(userDTO.getId());
                                    }
                                }
                                cwProjectReviewNew.setReviewStatus(reportData.getStatus());

                                cwProjectReviewNew.setTenantId("ccpm");
                                // 复核信息
                                cwProjectReviewNew.setId(recordsVo.getPrdId());
                                cwProjectReviewNew.setProjectId(recordsVo.getId());
                                if (reportInfo != null) {
                                    cwProjectReviewNew.setReportId(reportInfo.getId());
                                }
                                //复核通过时间
                                cwProjectReviewNew.setCheckCompleteTime(recordsVo.getFirstAuditDate());

                                // 下一节点审核人
                                if (StringUtils.isNotBlank(recordsVo.getBzshbUserName())) {
                                    UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(recordsVo.getBzshbUserName());
                                    if (userDTO != null) {
                                        cwProjectReviewNew.setReviewBy(userDTO.getId());
                                    }
                                }

                                cwProjectReviewNew.setCreateTime(reportData.getCreateDate());
                                cwProjectReviewNew.setUpdateTime(reportData.getUpdateDate());
                                CwProjectReviewNew byId = cwProjectReviewNewMapper.getById(cwProjectReviewNew.getId());
                                if (byId != null){
                                    cwProjectReviewNewMapper.updateById(cwProjectReviewNew);
                                }else {
                                    cwProjectReviewNewMapper.insert(cwProjectReviewNew);
                                }

                                if ("5".equals(cwProjectReviewNew.getReviewStatus())) {
                                    CwProjectRecords records = new CwProjectRecords();
                                    records.setId(cwProjectReviewNew.getProjectId());
                                    records.setReportReview("1"); // 已开始报告复核
                                    cwProjectRecordsMapper.updatereportReviewById(records);
                                }

                                if (CollectionUtils.isNotEmpty(reportData.getConsultants())) {
                                    for (RuralReportConsultant consultant : reportData.getConsultants()) {
                                        if (consultant != null) {
                                            CwProjectReviewNewTeam reviewNewTeam = new CwProjectReviewNewTeam();
                                            UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(recordsVo.getCreateName());
                                            if (userDTO != null) {
                                                reviewNewTeam.setCreateById(userDTO.getId());
                                                reviewNewTeam.setUpdateById(userDTO.getId());
                                            }
                                            reviewNewTeam.setCreateTime(recordsVo.getCreateDate());
                                            reviewNewTeam.setUpdateTime(recordsVo.getUpdateTime());
                                            reviewNewTeam.setReportId(reportInfo.getId());
                                            if (StringUtils.isNotBlank(consultant.getRole())) {
                                                reviewNewTeam.setUserRole(consultant.getRole());
                                                // 根据角色处理
                                                if (consultant.getRole().equals("负责人")) {
                                                    reviewNewTeam.setDetailNumber("1");
                                                    UserDTO userDTO2 = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(consultant.getZixunyuanName());
                                                    if (userDTO2 != null) {
                                                        reviewNewTeam.setUserId(userDTO2.getId());
                                                    }
                                                }
                                                // 其他角色处理
                                                if (consultant.getRole().equals("技术负责人")) {
                                                    reviewNewTeam.setDetailNumber("2");
                                                    if (StringUtils.isNotBlank(consultant.getZixunyuanName())) {
                                                        String substring = consultant.getZixunyuanName().substring(consultant.getZixunyuanName().indexOf("(")+1, consultant.getZixunyuanName().lastIndexOf("代"));
                                                        UserDTO userDTO2 = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(substring);
                                                        if (userDTO2 != null) {
                                                            reviewNewTeam.setUserId(userDTO2.getId());
                                                        }
                                                    }
                                                }
                                                if (consultant.getRole().equals("咨询员")) {
                                                    reviewNewTeam.setDetailNumber("3");
                                                    UserDTO userDTO2 = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(consultant.getZixunyuanName());
                                                    if (userDTO2 != null) {
                                                        reviewNewTeam.setUserId(userDTO2.getId());
                                                    }
                                                }
                                            }
                                            reviewNewTeam.setId(consultant.getId());
                                            reviewNewTeam.setContent(consultant.getWordnr());
                                            reviewNewTeam.setOpinion(consultant.getAuditOpinion());
                                            reviewNewTeam.setTenantId("ccpm");

                                            newTeamMapper.insert(reviewNewTeam);
                                        }
                                    }
                                }
                            }
                        } catch (Exception e) {
                            System.out.println("Error: " + e);
                            // 捕获外层异常，避免事务回滚
                        }
                    }
                }
            }
        }
    }

    /**
     * 获取档案信息
     * @param allUserInfo
     */
    @Transactional(rollbackFor = Exception.class, noRollbackFor = SQLException.class)
    public void getAllRuralProjectcontentinfo(List<UserDTO> allUserInfo) {
        Object projectcontentinfo = flowRequest.getAllRuralProjectcontentinfo();

        if (ObjectUtils.isNotEmpty(projectcontentinfo)){

            List<RuralProjectcontentinfoVo> ruralProjectcontentinfoVos = JSONArray.parseArray(projectcontentinfo.toString(), RuralProjectcontentinfoVo.class);
            if (ruralProjectcontentinfoVos != null){
                for (RuralProjectcontentinfoVo ruralProjectcontentinfoVo : ruralProjectcontentinfoVos) {
                    //成果文件
                    if (ruralProjectcontentinfoVo.getFileAttachmentList() != null){
                        List<ProjectTemplateInfoVo> fileAttachmentList = ruralProjectcontentinfoVo.getFileAttachmentList();
                        for (ProjectTemplateInfoVo projectTemplateInfoVo : fileAttachmentList) {
                            String attId = "";
                            String level = "";
                            String type = "";
                            if (StringUtils.isNotBlank(ruralProjectcontentinfoVo.getProjectLevel())){
                                if (ruralProjectcontentinfoVo.getProjectLevel().equals("1")){
                                    level = "2";
                                }else {
                                    level = "1";
                                }
                            }else {
                                level = "2";
                            }
                            if (StringUtils.isNotBlank(ruralProjectcontentinfoVo.getProjectType())){
                                if (ruralProjectcontentinfoVo.getProjectType().equals("2")){
                                    type = "1";
                                }else {
                                    type = "2";
                                }
                            }
                            //根据名字找到对应节点的id
                            if (StringUtils.isNotBlank(projectTemplateInfoVo.getAttachName())){
                                attId = projectDictMapper.findByName(projectTemplateInfoVo.getAttachName(),ruralProjectcontentinfoVo.getAttachmentProjectSort(),level,type);
                            }
                            if (projectTemplateInfoVo.getWorkAttachments() != null){
                                saveContentInfo(projectTemplateInfoVo.getWorkAttachments(),attId);
                            }
                        }
                    }
                    //依据文件
                    if (ruralProjectcontentinfoVo.getFileGistdataList() != null){
                        List<ProjectTemplateInfoVo> fileGistdataList = ruralProjectcontentinfoVo.getFileGistdataList();
                        for (ProjectTemplateInfoVo projectTemplateInfoVo : fileGistdataList) {
                            String attId = "";
                            String level = "";
                            String type = "";
                            if (StringUtils.isNotBlank(ruralProjectcontentinfoVo.getProjectLevel())){
                                if (ruralProjectcontentinfoVo.getProjectLevel().equals("1")){
                                    level = "2";
                                }else {
                                    level = "1";
                                }
                            }else {
                                level = "2";
                            }
                            if (StringUtils.isNotBlank(ruralProjectcontentinfoVo.getProjectType())){
                                if (ruralProjectcontentinfoVo.getProjectType().equals("2")){
                                    type = "1";
                                }else {
                                    type = "2";
                                }
                            }
                            //根据名字找到对应节点的id
                            if (StringUtils.isNotBlank(projectTemplateInfoVo.getAttachName())){
                                attId = projectDictMapper.findByName(projectTemplateInfoVo.getAttachName(),ruralProjectcontentinfoVo.getAttachmentProjectSort(),level,type);
                            }
                            if (projectTemplateInfoVo.getWorkAttachments() != null){
                                saveContentInfo(projectTemplateInfoVo.getWorkAttachments(),attId);
                            }
                        }
                    }
                    //其他文件
                    if (ruralProjectcontentinfoVo.getFileOtherList() != null){
                        List<ProjectTemplateInfoVo> fileOtherList = ruralProjectcontentinfoVo.getFileOtherList();
                        for (ProjectTemplateInfoVo projectTemplateInfoVo : fileOtherList) {
                            String attId = "";
                            String level = "";
                            String type = "";
                            if (StringUtils.isNotBlank(ruralProjectcontentinfoVo.getProjectLevel())){
                                if (ruralProjectcontentinfoVo.getProjectLevel().equals("1")){
                                    level = "2";
                                }else {
                                    level = "1";
                                }
                            }else {
                                level = "2";
                            }
                            if (StringUtils.isNotBlank(ruralProjectcontentinfoVo.getProjectType())){
                                if (ruralProjectcontentinfoVo.getProjectType().equals("2")){
                                    type = "1";
                                }else {
                                    type = "2";
                                }
                            }
                            //根据名字找到对应节点的id
                            if (StringUtils.isNotBlank(projectTemplateInfoVo.getAttachName())){
                                attId = projectDictMapper.findByName(projectTemplateInfoVo.getAttachName(),ruralProjectcontentinfoVo.getAttachmentProjectSort(),level,type);
                            }
                            if (projectTemplateInfoVo.getWorkAttachments() != null){
                                saveContentInfo(projectTemplateInfoVo.getWorkAttachments(),attId);
                            }
                        }
                    }
                }
            }
        }
    }

    /*8
    获取项目信息
     */
    public void getProjectList( List<UserDTO> allUserInfo) throws Exception {
        //ccpm系统中的项目信息
        Object projectList = flowRequest.getProjectList();

        if(ObjectUtils.isNotEmpty(projectList)){
            List<RuralProjectRecordsVo> ruralProjectRecordsVos = JSONArray.parseArray(projectList.toString(), RuralProjectRecordsVo.class);
            //删除之前添加的数据
//            cwProjectRecordsMapper.deleteByTenantId();
//            cwProjectReviewNewMapper.deleteByTenantId();
//            cwProjectReportMapper.deleteByTenantId();
//            cwProjectInfoMapper.deleteByTenantId();
//            cwProjectReportSignAndIssueMapper.deleteByTenantId();
//            cwProjectReportOnlineArchivingMapper.deleteByTenantId();
//            cwProjectReportPaperArchivingMapper.deleteByTenantId();
            cwProjectClientContactMapper.deleteByTenantId();
            cwProjectClientInfoMapper.deleteByTenantId();
            cwProjectRecordsMapper.deletePlanByTenantId();
            cwProjectRecordsMapper.deleteMemberByTenantId();
            //将获取到的项目信息通过遍历的方式插入到数据表中
            if (CollectionUtils.isNotEmpty(ruralProjectRecordsVos)){
                for (RuralProjectRecordsVo recordsVo : ruralProjectRecordsVos) {
                    //项目
                    CwProjectRecords cwProjectRecords = new CwProjectRecords();

                    //报告
                    CwProjectReport report = new CwProjectReport();
                    CwProjectInfoData cwProjectInfoData = new CwProjectInfoData();
                    //报告签发
                    CwProjectReportSignAndIssue cwProjectReportSignAndIssue = new CwProjectReportSignAndIssue();
                    //电子归档
                    CwProjectReportOnlineArchiving cwProjectReportOnlineArchiving = new CwProjectReportOnlineArchiving();
                    //纸质归档
                    CwProjectReportPaperArchiving cwProjectReportPaperArchiving = new CwProjectReportPaperArchiving();

                    //项目
                    if (StringUtils.isNotBlank(recordsVo.getId())){
                        cwProjectRecords.setId(recordsVo.getId());//项目id
                        cwProjectRecords.setProjectNumber(recordsVo.getProjectId());//项目编号
                        cwProjectRecords.setContractId(recordsVo.getWorkContractInfo().getId());
                        cwProjectRecords.setProjectName(recordsVo.getProjectName());

                        if (StringUtils.isNotBlank(recordsVo.getProjectType())){
                            if (recordsVo.getProjectType().equals("2")){
                                cwProjectRecords.setProjectType("1");//造价
                                cwProjectRecords.setReportType(recordsVo.getAttachmentProjectSort()); //项目类别
                            }else {
                                cwProjectRecords.setProjectType("2");
                                cwProjectRecords.setReportType(recordsVo.getAttachmentProjectSort());
                            }
                        }
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()) {
                                UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getById(matchingUserId.get());
                                if (userDTO != null) {
                                    cwProjectRecords.setCreateById(userDTO.getId());
                                    cwProjectRecords.setUpdateById(userDTO.getId());
                                    cwProjectRecords.setOfficeId(userDTO.getOfficeDTO().getId());
                                }
                            }

                        }
                        cwProjectRecords.setCreateTime(recordsVo.getCreateDate());
                        cwProjectRecords.setTenantId("ccpm");
                        cwProjectRecords.setStatus("5");
                        //获取项目所在地
                        List<Area> areaDTO = SpringUtil.getBean(IAreaApi.class).getAreaDTOByName(recordsVo.getArea().getName());
                        if (areaDTO.size()>1){
                            //当出现两个相同的最后一级区域的时候去查询他们的上一级区域,然后根据上一级id进行添加
                            List<Area> parentArea = SpringUtil.getBean(IAreaApi.class).getAreaDTOByName(recordsVo.getCity());
                            for (Area area : areaDTO) {
                                for (Area parArea : parentArea) {
                                    if (area.getParentId().equals(parArea.getId())){
                                        cwProjectRecords.setAreaId(area.getId());
                                    }

                                }
                            }
                        }else {
                            if (ObjectUtils.isNotEmpty(areaDTO)){
                                for (Area area : areaDTO) {
                                    cwProjectRecords.setAreaId(area.getId());

                                }
                            }
                        }
                        //项目等级
                        if (StringUtils.isNotBlank(recordsVo.getSubmitMoney())){
                            if (recordsVo.getSubmitMoney().equals("1")){
                                cwProjectRecords.setProjectLevel("2");
                            }else {
                                cwProjectRecords.setProjectLevel("1");
                            }
                        }

                        //项目金额
                        if (ObjectUtils.isNotEmpty(recordsVo.getSubmitScale())){
                            cwProjectRecords.setProjectMoney(String.valueOf(recordsVo.getSubmitScale()));
                        }

                        //项目开始时间结束时间
                        cwProjectRecords.setProjectStartTime(recordsVo.getStartDate());
                        cwProjectRecords.setProjectEndTime(recordsVo.getEndDate());
                        //工程类型
                        cwProjectRecords.setEngineeringType(recordsVo.getEngineeringType());
                        //项目负责人
                        if (StringUtils.isNotBlank(recordsVo.getProjectMasterPhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getProjectMasterPhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getById(matchingUserId.get());
                                if (userDTO != null){
                                    cwProjectRecords.setProjectLeaderId(userDTO.getId());
                                }
                            }

                        }
                        if (StringUtils.isNotBlank(recordsVo.getLeaderNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getLeaderNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getById(matchingUserId.get());
                                if (userDTO != null){
                                    cwProjectRecords.setProjectMasterId(userDTO.getId());
                                }
                            }

                        }
                        CwProjectRecords projectRecords = cwProjectRecordsMapper.selectById(cwProjectRecords.getId());
                        if (projectRecords != null){
                            cwProjectRecordsMapper.updateById(cwProjectRecords);
                        }else {
                            cwProjectRecordsMapper.insert(cwProjectRecords);
                        }
                        //项目联系人
                        if (CollectionUtils.isNotEmpty(recordsVo.getWorkClientLinkmanList())){
                            for (WorkClientLinkman workClientLinkman : recordsVo.getWorkClientLinkmanList()) {
                                if (workClientLinkman.getClientId() != null){
                                    CwProjectClientContact cwProjectClientContact = new CwProjectClientContact();
                                    cwProjectClientContact.setProjectId(recordsVo.getId());
                                    cwProjectClientContact.setClientId(workClientLinkman.getId());
                                    cwProjectClientContact.setEmail(workClientLinkman.getEmail());
                                    cwProjectClientContact.setContactFirst(workClientLinkman.getLinkMobile());
                                    cwProjectClientContact.setContactSecond(workClientLinkman.getLinkPhone());
                                    cwProjectClientContact.setName(workClientLinkman.getName());
                                    cwProjectClientContact.setPosition(workClientLinkman.getPosition());
                                    if (StringUtils.isNotBlank(workClientLinkman.getOffice())){
                                        OfficeDTO officeDTOByName = SpringUtil.getBean(IOfficeApi.class).getOfficeDTOByName(workClientLinkman.getOffice());
                                        if (officeDTOByName != null){
                                            cwProjectClientContact.setOfficeId(officeDTOByName.getId());
                                        }
                                    }
                                    cwProjectClientContact.setClientContactId(workClientLinkman.getClientId().getId());
                                    cwProjectClientContact.setTenantId("ccpm");
                                    cwProjectClientContactMapper.insert(cwProjectClientContact);

                                    //中间表
                                    CwProjectClientInfo cwProjectClientInfo = new CwProjectClientInfo();
                                    cwProjectClientInfo.setClientId(workClientLinkman.getClientId().getId());
                                    cwProjectClientInfo.setProjectId(recordsVo.getId());
                                    cwProjectClientInfo.setTenantId("ccpm");
                                    cwProjectClientInfoMapper.insert(cwProjectClientInfo);

                                }
                            }
                        }
                        //施工方信息
                        if (null != recordsVo.getWorkConstructionLinkmanList() && recordsVo.getWorkConstructionLinkmanList().size()>0){
                            //先根据项目id删除施工方信息
                            customerInfoService.remove(new QueryWrapper<PartialCustomerInfo>().lambda()
                                    .eq(PartialCustomerInfo::getRecordsId,recordsVo.getId()));
                            //重新添加施工方信息
                            List<WorkClientLinkman> workConstructionLinkmanList = recordsVo.getWorkConstructionLinkmanList();
                            for (int i = 0; i < workConstructionLinkmanList.size(); i++) {
                                PartialCustomerInfo customerInfo = new PartialCustomerInfo();
                                BeanUtil.copyProperties(workConstructionLinkmanList.get(i), customerInfo);
                                customerInfo.setId(UUID.randomUUID().toString().replace("-", ""));
                                customerInfo.setCreateById(cwProjectRecords.getCreateById());
                                customerInfo.setCreateTime(new Date());
                                customerInfo.setUpdateById(cwProjectRecords.getUpdateById());
                                customerInfo.setUpdateTime(new Date());
                                customerInfo.setRecordsId(cwProjectRecords.getId());
                                customerInfoService.save(customerInfo);
                            }

                        }

                    }
                    //项目组成员,将创建人添加到项目组成员中
                    Set<String> strings = new HashSet<>();
                    strings.add(cwProjectRecords.getCreateById());
                    strings.add(cwProjectRecords.getProjectMasterId());
                    strings.add(cwProjectRecords.getProjectLeaderId());
                    for (String string : strings) {

                        CwProjectMembers cwProjectMembers = new CwProjectMembers();
                        cwProjectMembers.setId(UUID.randomUUID().toString().replace("-", ""));
                        cwProjectMembers.setUserId(string);
                        cwProjectMembers.setProjectId(cwProjectRecords.getId());
                        cwProjectMembers.setIsImportant("1");
                        cwProjectMembers.setStatus("0");
                        cwProjectMembers.setTenantId("ccpm");
                        cwProjectMembers.setCreateById(cwProjectRecords.getCreateById());
                        cwProjectMembers.setCreateTime(new Date());
                        cwProjectMembers.setUpdateById(cwProjectRecords.getUpdateById());
                        cwProjectMembers.setUpdateTime(new Date());
                        cwProjectMembersMapper.insert(cwProjectMembers);
                    }

                    //将项目与项目计划绑定
                    CwProjectPlan cwProjectPlan = new CwProjectPlan();
                    cwProjectPlan.setId(UUID.randomUUID().toString().replace("-", ""));
                    cwProjectPlan.setProjectId(cwProjectRecords.getId());
                    cwProjectPlan.setTenantId("ccpm");
                    cwProjectPlan.setCreateById(cwProjectRecords.getCreateById());
                    cwProjectPlan.setCreateTime(new Date());
                    cwProjectPlan.setUpdateById(cwProjectRecords.getUpdateById());
                    cwProjectPlan.setUpdateTime(new Date());
                    cwProjectPlanMapper.insert(cwProjectPlan);


                    //报告
                    if (StringUtils.isNotBlank(recordsVo.getPrdId())){
                        report.setProjectId(recordsVo.getId());
                        report.setStatus("5");
                        report.setTenantId("ccpm");
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                report.setCreateById(matchingUserId.get());
                                report.setUpdateById(matchingUserId.get());
                            }

                        }
                        report.setCreateTime(recordsVo.getCreateDate());
                        List<CwProjectReportData> reportData = cwProjectReportMapper.getByProjectId(cwProjectRecords.getId());
                        String id = "";
                        if (CollectionUtil.isNotEmpty(reportData)){
                            id = reportData.get(0).getId();
                        }else {
                            id = UUID.randomUUID().toString().replace("-", "");
                        }
                        //报告信息
                        report.setId(id);
                        if (ObjectUtils.isNotEmpty(reportData)){
                            cwProjectReportMapper.updateById(report);
                        }else {
                            cwProjectReportMapper.insert(report);
                        }


                        //报告编号

                        cwProjectInfoData.setReportId(id);
                        cwProjectInfoData.setReportNo(recordsVo.getProjectReportNumber());
                        cwProjectInfoData.setTenantId("ccpm");
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                cwProjectInfoData.setCreateById(matchingUserId.get());
                                cwProjectInfoData.setUpdateById(matchingUserId.get());
                            }

                        }
                        cwProjectInfoData.setCreateTime(recordsVo.getCreateTime());
                        String id1 = "";
                        CwProjectInfoData byReportId = cwProjectInfoMapper.getByReportId(id);
                        if (ObjectUtils.isNotEmpty(byReportId)){
                            id1 = byReportId.getId();
                        }else {
                            id1= UUID.randomUUID().toString().replace("-", "");
                        }

                        cwProjectInfoData.setId(id1);
                        if (byReportId != null){
                            cwProjectInfoMapper.updateById(cwProjectInfoData);
                        }else {
                            cwProjectInfoMapper.insert(cwProjectInfoData);
                        }

                    }


                    //报告签发
                    if (StringUtils.isNotBlank(recordsVo.getPrdtId())){
                        cwProjectReportSignAndIssue.setId(recordsVo.getPrdtId());
                        cwProjectReportSignAndIssue.setProjectId(recordsVo.getId());
                        if (ObjectUtils.isNotEmpty(recordsVo.getProjectReportStatusTwo())){
                            cwProjectReportSignAndIssue.setStatus(recordsVo.getProjectReportStatusTwo().toString());
                        }else {
                            cwProjectReportSignAndIssue.setStatus("");

                        }
                        cwProjectReportSignAndIssue.setTenantId("ccpm");
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                cwProjectReportSignAndIssue.setCreateById(matchingUserId.get());
                                cwProjectReportSignAndIssue.setUpdateById(matchingUserId.get());
                            }

                        }
                        cwProjectReportSignAndIssue.setCreateTime(recordsVo.getCreateDate());
                        cwProjectReportSignAndIssue.setReportId(report.getId());
                        CwProjectReportSignAndIssue byId = cwProjectReportSignAndIssueMapper.getById(cwProjectReportSignAndIssue.getId());
                        if (byId != null){
                            cwProjectReportSignAndIssueMapper.updateById(cwProjectReportSignAndIssue);
                        }else {
                            cwProjectReportSignAndIssueMapper.insert(cwProjectReportSignAndIssue);
                        }
                    }

                    //电子归档
                    if (StringUtils.isNotBlank(recordsVo.getPrrId())){
                        cwProjectReportOnlineArchiving.setId(recordsVo.getPrrId());
                        cwProjectReportOnlineArchiving.setReportId(report.getId());
                        if (ObjectUtils.isNotEmpty(recordsVo.getProjectReportRecordStatus())){
                            cwProjectReportOnlineArchiving.setStatus(recordsVo.getProjectReportRecordStatus().toString());
                        }else {
                            cwProjectReportOnlineArchiving.setStatus("");
                        }
                        cwProjectReportOnlineArchiving.setTenantId("ccpm");
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                cwProjectReportOnlineArchiving.setCreateById(matchingUserId.get());
                                cwProjectReportOnlineArchiving.setUpdateById(matchingUserId.get());
                            }

                        }
                        cwProjectReportOnlineArchiving.setCreateTime(recordsVo.getReportRecordBeginDate());
                        CwProjectReportOnlineArchiving projectReportOnlineArchiving = cwProjectReportOnlineArchivingMapper.selectById(cwProjectReportOnlineArchiving.getId());
                        if (projectReportOnlineArchiving != null){
                            cwProjectReportOnlineArchivingMapper.updateById(cwProjectReportOnlineArchiving);
                        }else {
                            cwProjectReportOnlineArchivingMapper.insert(cwProjectReportOnlineArchiving);
                        }
                    }
                    //纸质归档
                    if (StringUtils.isNotBlank(recordsVo.getPrrdId())){
                        //纸质归档
                        cwProjectReportPaperArchiving.setId(recordsVo.getPrrdId());
                        cwProjectReportPaperArchiving.setReportId(report.getId());
                        if (ObjectUtils.isNotEmpty(recordsVo.getDownProjectReportRecordStatus())){
                            cwProjectReportPaperArchiving.setStatus(recordsVo.getDownProjectReportRecordStatus().toString());
                        }else{
                            cwProjectReportPaperArchiving.setStatus("");
                        }
                        cwProjectReportPaperArchiving.setTenantId("ccpm");
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                cwProjectReportPaperArchiving.setCreateById(matchingUserId.get());
                                cwProjectReportPaperArchiving.setUpdateById(matchingUserId.get());
                            }

                        }
                        cwProjectReportPaperArchiving.setCreateTime(recordsVo.getCreateDate());
                        CwProjectReportPaperArchiving projectReportPaperArchiving = cwProjectReportPaperArchivingMapper.selectById(cwProjectReportPaperArchiving.getId());
                        if (projectReportPaperArchiving != null){
                            cwProjectReportPaperArchivingMapper.updateById(cwProjectReportPaperArchiving);
                        }else {
                            cwProjectReportPaperArchivingMapper.insert(cwProjectReportPaperArchiving);

                        }
                    }
                }
            }
        }


    }


    /**
     * 获取合同信息
     */
    public void getWorkContract( List<UserDTO> allUserInfo){
        //ccpm系统中的合同信息
        Object contractList = flowRequest.getWorkContractList();

        if (ObjectUtils.isNotEmpty(contractList)){
            List<WorkContractInfoVo> workContractInfoVos = JSONArray.parseArray(contractList.toString(), WorkContractInfoVo.class);
            //删除之前添加的合同数据
            contractInfoMapper.deleteByTenantId();
//            contractFilePaperMapper.deleteByTenantId();
            contractParticipantMapper.deleteByTenantId();
            //新增数据
            if (CollectionUtils.isNotEmpty(workContractInfoVos)){
                for (WorkContractInfoVo contractInfoVo : workContractInfoVos) {
                    ContractInfo workContractInfo = new ContractInfo();
                    workContractInfo.setId(contractInfoVo.getId());//id
                    if (StringUtils.isNotBlank(contractInfoVo.getCreateUserMobile())){
                        Optional<UserDTO> matchingUser = allUserInfo.stream()
                                .filter(user -> user.getMobile().equals(contractInfoVo.getCreateUserMobile()))
                                .findFirst();
                        if (matchingUser.isPresent()){
                            UserDTO userDTO = matchingUser.get();
                            workContractInfo.setCreateById(userDTO.getId());
                            workContractInfo.setUpdateById(userDTO.getId());
                            workContractInfo.setDepartment(userDTO.getOfficeDTO().getId());
                        }
                    }
                    workContractInfo.setCreateTime(contractInfoVo.getCreateDate());
                    workContractInfo.setContractName(contractInfoVo.getName());//合同名称
                    workContractInfo.setContractNo(contractInfoVo.getContractNum());//合同编号
                    workContractInfo.setClientContacts(contractInfoVo.getClient().getId());//客户id
                    workContractInfo.setStatus(contractInfoVo.getContractState());//合同状态
                    workContractInfo.setSigningDate(contractInfoVo.getContractDate());//签约日期
                    workContractInfo.setContractType(contractInfoVo.getContractTypeDoc()); //合同类型
                    //合同金额
                    if (StringUtils.isNotBlank(contractInfoVo.getContractPrice())){
                        double newPrice = Double.parseDouble(contractInfoVo.getContractPrice());
                        workContractInfo.setContractAmount(newPrice);
                        workContractInfo.setActualContractAmount(newPrice);
                    }

                    workContractInfo.setTenantId("ccpm");
                    //合同金额类别
                    if (StringUtils.isNotBlank(contractInfoVo.getContractInformation())){
                        if ("0".equals(contractInfoVo.getContractInformation())){
                            workContractInfo.setContractAmountType("1");//金额合同
                        }else if ("1".equals(contractInfoVo.getContractInformation())){
                            workContractInfo.setContractAmountType("2");//费率合同
                        }
                    }
                    //收费标准
                    if (StringUtils.isNotBlank(contractInfoVo.getChargeCriterion())){
                        String dictValue = SpringUtil.getBean(IDictApi.class).getDictValue(contractInfoVo.getChargeCriterion(), "contract_fee_new", "");
                        workContractInfo.setFees(dictValue);
                    }
                    if (StringUtils.isNotBlank(contractInfoVo.getOtherDetails())){
                        workContractInfo.setContractFee(contractInfoVo.getOtherDetails());
                    }
                    //对方合同编号
                    workContractInfo.setContractOpposite(contractInfoVo.getContractOpposite());
                    contractInfoMapper.insert(workContractInfo);
                    //合同签约方信息
                    ContractParticipant contractParticipant = new ContractParticipant();
                    contractParticipant.setContractInfoId(workContractInfo.getId());
                    contractParticipant.setCustomerNo(contractInfoVo.getClient().getNumber());//客户no
                    contractParticipant.setCustomerName(contractInfoVo.getClient().getName());//客户no
                    contractParticipant.setTenantId("ccpm");
                    contractParticipant.setCreateById(workContractInfo.getCreateById());
                    contractParticipant.setUpdateById(workContractInfo.getUpdateById());
                    contractParticipantMapper.insert(contractParticipant);
                    //保存合同归档信息
                    ContractFilePaper workContractFile = new ContractFilePaper();
                    workContractFile.setContractInfoId(contractInfoVo.getId());
                    workContractFile.setFiledNo(contractInfoVo.getRecordNum());//案卷号
                    workContractFile.setConfirmFiledNo(contractInfoVo.getRecordNum());//案卷号
                    workContractFile.setFiledPaperType(contractInfoVo.getContrractRecordStatus());
                    workContractFile.setTenantId("ccpm");
                    workContractFile.setCreateTime(contractInfoVo.getCreateDate());
                    if (StringUtils.isNotBlank(contractInfoVo.getCreateUserMobile())){
                        Optional<String> matchingUserId = allUserInfo.stream()
                                .filter(user -> user.getMobile().equals(contractInfoVo.getCreateUserMobile()))
                                .map(UserDTO::getId)
                                .findFirst();
                        if (matchingUserId.isPresent()){
                            workContractFile.setCreateById(matchingUserId.get());
                            workContractFile.setUpdateById(matchingUserId.get());
                        }
                    }
                    ContractFilePaper contractFilePaper = contractFilePaperMapper.selectFilePaperByContractInfoId(contractInfoVo.getId());
                    if (null != contractFilePaper) {
                        workContractFile.setId(contractFilePaper.getId());
                        contractFilePaperMapper.updateById(workContractFile);
                    }else {
                        contractFilePaperMapper.insert(workContractFile);
                    }
                    if (contractInfoVo.getWorkAttachments()!=null){
                        SpringUtil.getBean ( IWorkAttachmentApi.class ).deleteByAttachmentId(contractInfoVo.getId());
                        UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(contractInfoVo.getCreateUser());
                        if (userDTO != null){
                            saveWorkContractFiles(contractInfoVo.getWorkAttachments(),userDTO,contractInfoVo.getId(),"workcontract");
                        }
                    }


                }
            }
        }

    }

    /**
     * 保存附件信息
     * @param list 待保存的附件列表
     * @param userDTO 当前登录用户
     * @param id 关联id
     */
    @Transactional(rollbackFor = Exception.class)
    public void saveWorkContractFiles(List<WorkClientAttachment> list, UserDTO userDTO, String id,String flag) {
        int j = 1;
        for (WorkClientAttachment dto : list) {
            WorkAttachmentInfo i = new WorkAttachmentInfo();
            //包含了url、size、name
            i.setId(UUID.randomUUID().toString().replace("-", ""));
//            i.getCreateBy().setId(userDTO.getId());
            i.setCreateTime(new Date());
//            i.getUpdateBy().setId(userDTO.getId());
            i.setUpdateTime(new Date());
            i.setDelFlag(0);
            i.setUrl(dto.getUrl());
            //文件类型处理
            List<String> strings = Arrays.asList(dto.getAttachmentName().split("\\."));
            if (CollectionUtil.isNotEmpty(strings)) {
                i.setType(strings.get(1));
            }
            i.setAttachmentId(id);
            i.setAttachmentName(dto.getAttachmentName());
            i.setAttachmentFlag(flag);
            i.setFileSize(dto.getFileSize());
            i.setSort(j);
            Map<String,String> map = new HashMap<>();
            String workAttachment = JSON.toJSONString((i));
            String userDTOInfo = JSON.toJSONString((userDTO));
            map.put("workAttachment",workAttachment);
            map.put("userDTO",userDTOInfo);
            SpringUtil.getBean ( IWorkAttachmentApi.class ).insertWorkAttachment(map);
            j++;
        }
    }

    /**
     * 保存档案信息
     * @param list 待保存的附件列表
     * @param userDTO 当前登录用户
     * @param id 关联id
     */
    @Transactional(rollbackFor = Exception.class)
    public void saveContentInfo(List<WorkClientAttachment> list,String attId) {
        int j = 1;
        for (WorkClientAttachment dto : list) {
            SpringUtil.getBean ( IWorkAttachmentApi.class ).deleteById(dto.getId());

            WorkAttachmentInfo i = new WorkAttachmentInfo();
            //包含了url、size、name
            i.setId(dto.getId());
//            i.getCreateBy().setId(userDTO.getId());
            i.setCreateTime(dto.getCreateDate());
//            i.getUpdateBy().setId(userDTO.getId());
            i.setUpdateTime(dto.getUpdateDate());
            i.setDelFlag(0);
            i.setUrl(dto.getUrl());
            //文件类型处理
            i.setType(dto.getType());
            i.setAttachmentId(attId);
            i.setModuleType(dto.getProjectId());
            i.setAttachmentName(dto.getAttachmentName());
            i.setAttachmentFlag("ccpmWorkClient");
            if (StringUtils.isNotBlank(dto.getFileSize())){
                i.setFileSize(dto.getFileSize());
            }else {
                i.setFileSize("0");
            }
            i.setSort(j);
            Map<String,String> map = new HashMap<>();
            String workAttachment = JSON.toJSONString((i));
            UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(dto.getCreateName());
            if (userDTO != null){
                String userDTOInfo = JSON.toJSONString((userDTO));
                map.put("userDTO",userDTOInfo);
            }
            map.put("workAttachment",workAttachment);
            SpringUtil.getBean ( IWorkAttachmentApi.class ).insertWorkAttachment(map);
            j++;
        }
    }


    //获取ccpm中所有的客户信息
    public void getAllClient( List<UserDTO> allUserInfo){

        Object clientList = flowRequest.getClientList();

        if (ObjectUtils.isNotEmpty(clientList)){
            List<WorkClientInfoVo> workClientInfoVos = JSONArray.parseArray(clientList.toString(), WorkClientInfoVo.class);
            //删除本系统中所有之前新增的ccpm系统中的数据
            cwWorkClientBaseMapper.deleteByTenantId();
            cwWorkClientBillingMapper.deleteByTenantId();
            cwWorkClientTypeMapper.deleteByTenantId();
            cwWorkClientBaseMapper.deleteLinkmanByTenantId();
            for (WorkClientInfoVo workClientInfoVo : workClientInfoVos) {
                //客户基本信息
                CwWorkClientBase cwWorkClientBase = new CwWorkClientBase();
                cwWorkClientBase.setId(workClientInfoVo.getId());
                if (StringUtils.isNotBlank(workClientInfoVo.getCreateMobile())){
                    Optional<String> matchingUserId = allUserInfo.stream()
                            .filter(user -> user.getMobile().equals(workClientInfoVo.getCreateMobile()))
                            .map(UserDTO::getId)
                            .findFirst();
                    if (matchingUserId.isPresent()){
                        cwWorkClientBase.setCreateById(matchingUserId.get());
                        cwWorkClientBase.setUpdateById(matchingUserId.get());
                        cwWorkClientBase.setUpdateUser(matchingUserId.get());
                    }

                }
                cwWorkClientBase.setNo(workClientInfoVo.getNumber()); //客户编号
                cwWorkClientBase.setName(workClientInfoVo.getName());//客户名称
                cwWorkClientBase.setIsUscCode(workClientInfoVo.getHasUscc()+"");//是否有统一社会信用代码
                cwWorkClientBase.setUscCode(workClientInfoVo.getUscCode());//统一社会信用代码
                cwWorkClientBase.setAddress(workClientInfoVo.getRegisterAddress());//地址
                cwWorkClientBase.setMobile(workClientInfoVo.getTelephone()); //电话
                if (StringUtils.isNotBlank(workClientInfoVo.getCompanyIndustry())){
                    String dictValue = SpringUtil.getBean(IDictApi.class).getDictValue(workClientInfoVo.getCompanyIndustry(), "cw_work_client_industry", "");
                    cwWorkClientBase.setIndustry(dictValue); //所属行业
                }

                cwWorkClientBase.setStatus("5");
                cwWorkClientBase.setTenantId("ccpm");
                cwWorkClientBase.setCreateTime(workClientInfoVo.getCreateDate());
                cwWorkClientBaseMapper.insert(cwWorkClientBase);
                //修改客户开户行信息
                if (CollectionUtils.isNotEmpty(workClientInfoVo.getWorkClientBankList())){
                    for (WorkClientBankVo workClientBank : workClientInfoVo.getWorkClientBankList()) {
                        CwWorkClientBilling clientBilling = new CwWorkClientBilling();
                        clientBilling.setId(workClientBank.getId());
                        clientBilling.setClientId(workClientBank.getClientId().getId());
                        clientBilling.setAccountHolder(workClientBank.getOurBank());//开户行
                        clientBilling.setAccount(workClientBank.getBankNumber());//银行账号
                        if (StringUtils.isNotBlank(workClientInfoVo.getCreateMobile())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(workClientInfoVo.getCreateMobile()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                clientBilling.setCreateById(matchingUserId.get());
                                clientBilling.setUpdateById(matchingUserId.get());
                            }

                        }
                        clientBilling.setCreateTime(workClientInfoVo.getCreateDate());
                        clientBilling.setTenantId("ccpm");
                        cwWorkClientBillingMapper.insert(clientBilling);

                    }
                }
                //修改客户类型信息
                CwWorkClientType cwWorkClientType = new CwWorkClientType();
                cwWorkClientType.setIsListed("0");
                cwWorkClientType.setTenantId("ccpm");
                cwWorkClientType.setClientId(workClientInfoVo.getId());
                cwWorkClientType.setCreateTime(workClientInfoVo.getCreateDate());
                if (StringUtils.isNotBlank(workClientInfoVo.getCreateMobile())){
                    Optional<String> matchingUserId = allUserInfo.stream()
                            .filter(user -> user.getMobile().equals(workClientInfoVo.getCreateMobile()))
                            .map(UserDTO::getId)
                            .findFirst();
                    if (matchingUserId.isPresent()){
                        cwWorkClientType.setCreateById(matchingUserId.get());
                        cwWorkClientType.setUpdateById(matchingUserId.get());
                    }
                }
                cwWorkClientTypeMapper.insert(cwWorkClientType);

                //客户联系人
                CwWorkClientContact cwWorkClientContact = new CwWorkClientContact();
                if (workClientInfoVo.getWorkClientLinkmanList() != null){
                    for (WorkClientLinkman clientLinkman : workClientInfoVo.getWorkClientLinkmanList()) {
                        cwWorkClientContact.setId(clientLinkman.getId());
                        cwWorkClientContact.setTenantId("ccpm");
                        cwWorkClientContact.setClientId(workClientInfoVo.getId());
                        cwWorkClientContact.setEmail(clientLinkman.getEmail());
                        cwWorkClientContact.setContactFirst(clientLinkman.getLinkMobile());
                        cwWorkClientContact.setContactSecond(clientLinkman.getLinkPhone());
                        if (StringUtils.isNotBlank(clientLinkman.getOffice())){
                            OfficeDTO officeDTOByName = SpringUtil.getBean(IOfficeApi.class).getOfficeDTOByName(clientLinkman.getOffice());
                            if (officeDTOByName != null){
                                cwWorkClientContact.setOfficeId(officeDTOByName.getId());
                            }
                        }
                        cwWorkClientContact.setName(clientLinkman.getName());
                        cwWorkClientContact.setPosition(clientLinkman.getPosition());
                        cwWorkClientContactMapper.insert(cwWorkClientContact);
                    }
                }

                if (workClientInfoVo.getWorkAttachments()!=null){
                    SpringUtil.getBean ( IWorkAttachmentApi.class ).deleteByAttachmentId(workClientInfoVo.getId());
                    UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(workClientInfoVo.getUserName());
                    if (userDTO != null){
                        saveWorkContractFiles(workClientInfoVo.getWorkAttachments(),userDTO,workClientInfoVo.getId(),"cw_work_client");
                    }
                }



            }
        }



    }

}
