package com.jeeplus.finance.ccpm.controller;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.extra.spring.SpringUtil;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.jeeplus.finance.ccpm.service.ccpm.FlowRequest;
import com.jeeplus.finance.ccpm.vo.*;
import com.jeeplus.finance.ccpm.vo.WorkClientLinkman;
import com.jeeplus.finance.contractRegistration.domain.ContractFilePaper;
import com.jeeplus.finance.contractRegistration.domain.ContractInfo;
import com.jeeplus.finance.contractRegistration.mapper.ContractFilePaperMapper;
import com.jeeplus.finance.contractRegistration.mapper.ContractInfoMapper;
import com.jeeplus.finance.projectRecords.domain.CwProjectClientContact;
import com.jeeplus.finance.projectRecords.domain.CwProjectRecords;
import com.jeeplus.finance.projectRecords.mapper.CwProjectClientContactMapper;
import com.jeeplus.finance.projectRecords.mapper.CwProjectRecordsMapper;
import com.jeeplus.finance.projectReport.domain.*;
import com.jeeplus.finance.projectReport.mapper.*;
import com.jeeplus.finance.workClientInfo.domain.*;
import com.jeeplus.finance.workClientInfo.mapper.*;
import com.jeeplus.finance.workClientInfo.service.dto.CwWorkClientBillingDTO;
import com.jeeplus.sys.domain.Area;
import com.jeeplus.sys.domain.WorkAttachmentInfo;
import com.jeeplus.sys.feign.*;
import com.jeeplus.sys.service.dto.OfficeDTO;
import com.jeeplus.sys.service.dto.UserDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.*;

@RestController
@RequestMapping(value = "/ccpmData/data")
public class receiveData {

    @Autowired
    private FlowRequest flowRequest;

    @Autowired
    private CwProjectRecordsMapper cwProjectRecordsMapper;

    @Autowired
    private CwProjectReviewNewMapper cwProjectReviewNewMapper;

    @Autowired
    private CwProjectReportMapper cwProjectReportMapper;

    @Autowired
    private CwProjectInfoMapper cwProjectInfoMapper;

    @Autowired
    private CwProjectReportSignAndIssueMapper cwProjectReportSignAndIssueMapper;

    @Autowired
    private CwProjectReportOnlineArchivingMapper cwProjectReportOnlineArchivingMapper;

    @Autowired
    private CwProjectReportPaperArchivingMapper cwProjectReportPaperArchivingMapper;

    @Autowired
    private ContractInfoMapper contractInfoMapper;

    @Autowired
    private CwWorkClientBaseMapper cwWorkClientBaseMapper;

    @Autowired
    private CwWorkClientBillingMapper cwWorkClientBillingMapper;

    @Autowired
    private CwWorkClientTypeMapper cwWorkClientTypeMapper;

    @Autowired
    private ContractFilePaperMapper contractFilePaperMapper;

    @Resource
    private CwWorkClientContactMapper cwWorkClientContactMapper;
    @Resource
    private CwProjectClientContactMapper cwProjectClientContactMapper;

    //保存客户信息
    @PostMapping("/saveClient")
    public void saveClient(@RequestBody WorkClientInfoVo workClientInfoVo) {
        //获取所有的用户信息
        List<UserDTO> allUserInfo = SpringUtil.getBean(IUserApi.class).getAllUserInfo();
        if (ObjectUtils.isNotEmpty(workClientInfoVo)) {
            //先进行删除
            cwWorkClientBaseMapper.deleteClientById(workClientInfoVo.getId());
            //客户基本信息
            CwWorkClientBase clientBase = new CwWorkClientBase();
            clientBase.setId(workClientInfoVo.getId());
            if (StringUtils.isNotBlank(workClientInfoVo.getCreateMobile())){
                Optional<String> matchingUserId = allUserInfo.stream()
                        .filter(user -> user.getMobile().equals(workClientInfoVo.getCreateMobile()))
                        .map(UserDTO::getId)
                        .findFirst();
                if (matchingUserId.isPresent()){
                    clientBase.setCreateById(matchingUserId.get());
                    clientBase.setUpdateById(matchingUserId.get());
                }

            }
            clientBase.setName(workClientInfoVo.getName());//客户名称
            clientBase.setIsUscCode(workClientInfoVo.getHasUscc() + "");//是否有统一社会信用代码
            clientBase.setUscCode(workClientInfoVo.getUscCode());//统一社会信用代码
            clientBase.setAddress(workClientInfoVo.getRegisterAddress());//地址
            clientBase.setMobile(workClientInfoVo.getTelephone()); //电话
            clientBase.setIndustry(workClientInfoVo.getCompanyIndustry()); //所属行业

            clientBase.setStatus("5");
            clientBase.setTenantId("ccpm");
            cwWorkClientBaseMapper.insert(clientBase);
            //修改客户开户行信息
            if (CollectionUtils.isNotEmpty(workClientInfoVo.getWorkClientBankList())) {
                List<CwWorkClientBillingDTO> client_id = cwWorkClientBillingMapper.getBillingListByClientId(new QueryWrapper<CwWorkClientBilling>().eq("client_id", workClientInfoVo.getId()));
                for (CwWorkClientBillingDTO cwWorkClientBillingDTO : client_id) {
                    cwWorkClientBillingMapper.deleteClientById(cwWorkClientBillingDTO.getId());
                }
                for (WorkClientBankVo workClientBank : workClientInfoVo.getWorkClientBankList()) {
                    CwWorkClientBilling clientBilling = new CwWorkClientBilling();
                    clientBilling.setId(workClientBank.getId());
                    clientBilling.setClientId(workClientBank.getClientId().getId());
                    clientBilling.setAccountHolder(workClientBank.getOurBank());//开户行
                    clientBilling.setAccount(workClientBank.getBankNumber());//银行账号
                    clientBilling.setTenantId("ccpm");
                    if (StringUtils.isNotBlank(workClientInfoVo.getCreateMobile())){
                        Optional<String> matchingUserId = allUserInfo.stream()
                                .filter(user -> user.getMobile().equals(workClientInfoVo.getCreateMobile()))
                                .map(UserDTO::getId)
                                .findFirst();
                        if (matchingUserId.isPresent()){
                            clientBilling.setCreateById(matchingUserId.get());
                            clientBilling.setUpdateById(matchingUserId.get());
                        }

                    }
                    cwWorkClientBillingMapper.insert(clientBilling);

                }
            }
            List<CwWorkClientType> clientTypes = cwWorkClientTypeMapper.selectList(new QueryWrapper<CwWorkClientType>().eq("client_id", workClientInfoVo.getId()));
            for (CwWorkClientType clientType : clientTypes) {
                cwWorkClientTypeMapper.deleteClientById(clientType.getId());
            }
            //修改客户类型信息
            CwWorkClientType cwWorkClientType = new CwWorkClientType();
            cwWorkClientType.setIsListed("0");
            cwWorkClientType.setTenantId("ccpm");
            cwWorkClientType.setClientId(workClientInfoVo.getId());
            if (StringUtils.isNotBlank(workClientInfoVo.getCreateMobile())){
                Optional<String> matchingUserId = allUserInfo.stream()
                        .filter(user -> user.getMobile().equals(workClientInfoVo.getCreateMobile()))
                        .map(UserDTO::getId)
                        .findFirst();
                if (matchingUserId.isPresent()){
                    cwWorkClientType.setCreateById(matchingUserId.get());
                    cwWorkClientType.setUpdateById(matchingUserId.get());
                }

            }
            cwWorkClientTypeMapper.insert(cwWorkClientType);
            //客户联系人
            cwWorkClientContactMapper.delete(new QueryWrapper<CwWorkClientContact>().eq("client_id",workClientInfoVo.getId()));
            CwWorkClientContact cwWorkClientContact = new CwWorkClientContact();
            if (workClientInfoVo.getWorkClientLinkmanList() != null){
                for (WorkClientLinkman clientLinkman : workClientInfoVo.getWorkClientLinkmanList()) {
                    cwWorkClientContact.setId(clientLinkman.getId());
                    cwWorkClientContact.setTenantId("ccpm");
                    cwWorkClientContact.setClientId(workClientInfoVo.getId());
                    cwWorkClientContact.setEmail(clientLinkman.getEmail());
                    cwWorkClientContact.setContactFirst(clientLinkman.getLinkMobile());
                    cwWorkClientContact.setContactSecond(clientLinkman.getLinkPhone());
                    if (StringUtils.isNotBlank(clientLinkman.getOffice())){
                        OfficeDTO officeDTOByName = SpringUtil.getBean(IOfficeApi.class).getOfficeDTOByName(clientLinkman.getOffice());
                        if (officeDTOByName != null){
                            cwWorkClientContact.setOfficeId(officeDTOByName.getId());
                        }
                    }
                    cwWorkClientContact.setName(clientLinkman.getName());
                    cwWorkClientContact.setPosition(clientLinkman.getPosition());
                    cwWorkClientContactMapper.insert(cwWorkClientContact);
                }
            }
            if (workClientInfoVo.getWorkAttachments()!=null){
                SpringUtil.getBean ( IWorkAttachmentApi.class ).deleteByAttachmentId(workClientInfoVo.getId());
                UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(workClientInfoVo.getUserName());
                if (userDTO != null){
                    saveWorkContractFiles(workClientInfoVo.getWorkAttachments(),userDTO,workClientInfoVo.getId(),"cw_work_client");
                }
            }
        }
    }

    //保存合同及归档信息
    @PostMapping(value = "saveContractInfo")
    public void saveContractInfo(@RequestBody WorkContractInfoVo workContractInfoVo){
        //获取所有的用户信息
        List<UserDTO> allUserInfo = SpringUtil.getBean(IUserApi.class).getAllUserInfo();
        if (ObjectUtils.isNotEmpty(workContractInfoVo)){
            //先进行删除
            contractInfoMapper.deleteInfoById(workContractInfoVo.getId());
            //保存合同基本信息
            ContractInfo workContractInfo = new ContractInfo();
            workContractInfo.setId(workContractInfoVo.getId());//id
            workContractInfo.setCreateTime(new Date());
            if (StringUtils.isNotBlank(workContractInfoVo.getCreateUserMobile())){
                Optional<String> matchingUserId = allUserInfo.stream()
                        .filter(user -> user.getMobile().equals(workContractInfoVo.getCreateUserMobile()))
                        .map(UserDTO::getId)
                        .findFirst();
                if (matchingUserId.isPresent()){
                    workContractInfo.setCreateById(matchingUserId.get());
                    workContractInfo.setUpdateById(matchingUserId.get());
                }

            }
            workContractInfo.setContractName(workContractInfoVo.getName());//合同名称
            workContractInfo.setContractNo(workContractInfoVo.getContractNum());//合同编号
            workContractInfo.setClientContacts(workContractInfoVo.getClient().getId());//客户id
            workContractInfo.setStatus(workContractInfoVo.getContractState());//合同状态
            //合同金额
            if (StringUtils.isNotBlank(workContractInfoVo.getContractPrice())){
                double newPrice = Double.parseDouble(workContractInfoVo.getContractPrice());
                workContractInfo.setContractAmount(newPrice);
                workContractInfo.setActualContractAmount(newPrice);
            }
            workContractInfo.setTenantId("ccpm");
            //合同金额类别
            if (StringUtils.isNotBlank(workContractInfoVo.getContractInformation())){
                if ("0".equals(workContractInfoVo.getContractInformation())){
                    workContractInfo.setContractAmountType("1");//金额合同
                }else if ("1".equals(workContractInfoVo.getContractInformation())){
                    workContractInfo.setContractAmountType("2");//费率合同
                }
            }
            if (StringUtils.isNotBlank(workContractInfoVo.getChargeCriterion())){
                String dictValue = SpringUtil.getBean(IDictApi.class).getDictValue(workContractInfoVo.getChargeCriterion(), "contract_fee_new", "");
                workContractInfo.setFees(dictValue);
            }
            if (StringUtils.isNotBlank(workContractInfoVo.getOtherDetails())){
                workContractInfo.setContractFee(workContractInfoVo.getOtherDetails());
            }
            contractInfoMapper.insert(workContractInfo);
            //先删除
            contractFilePaperMapper.deleteInfoByContractId(workContractInfoVo.getId());
            //保存合同归档信息
            ContractFilePaper workContractFile = new ContractFilePaper();
            workContractFile.setContractInfoId(workContractInfoVo.getId());
            workContractInfo.setFiledNo(workContractInfoVo.getRecordNum());//案卷号
            workContractFile.setFiledPaperType(workContractInfoVo.getContrractRecordStatus());
            workContractFile.setTenantId("ccpm");
            if (StringUtils.isNotBlank(workContractInfoVo.getCreateUserMobile())){
                Optional<String> matchingUserId = allUserInfo.stream()
                        .filter(user -> user.getMobile().equals(workContractInfoVo.getCreateUserMobile()))
                        .map(UserDTO::getId)
                        .findFirst();
                if (matchingUserId.isPresent()){
                    workContractFile.setCreateById(matchingUserId.get());
                    workContractFile.setUpdateById(matchingUserId.get());
                }

            }
            contractFilePaperMapper.insert(workContractFile);
            if (workContractInfoVo.getWorkAttachments()!=null){
                SpringUtil.getBean ( IWorkAttachmentApi.class ).deleteByAttachmentId(workContractInfoVo.getId());
                UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(workContractInfoVo.getCreateUser());
                if (userDTO != null){
                    saveWorkContractFiles(workContractInfoVo.getWorkAttachments(),userDTO,workContractInfoVo.getId(),"workcontract");

                }
            }
        }

    }

    /**
     * 保存附件信息
     * @param list 待保存的附件列表
     * @param userDTO 当前登录用户
     * @param id 关联id
     */
    @Transactional(rollbackFor = Exception.class)
    public void saveWorkContractFiles(List<WorkClientAttachment> list, UserDTO userDTO, String id, String flag) {
        int j = 1;
        for (WorkClientAttachment dto : list) {
            WorkAttachmentInfo i = new WorkAttachmentInfo();
            //包含了url、size、name
            i.setId(UUID.randomUUID().toString().replace("-", ""));
//            i.getCreateBy().setId(userDTO.getId());
            i.setCreateTime(new Date());
//            i.getUpdateBy().setId(userDTO.getId());
            i.setUpdateTime(new Date());
            i.setDelFlag(0);
            i.setUrl(dto.getUrl());
            //文件类型处理
            List<String> strings = Arrays.asList(dto.getAttachmentName().split("\\."));
            if (CollectionUtil.isNotEmpty(strings)) {
                i.setType(strings.get(1));
            }
            i.setAttachmentId(id);
            i.setAttachmentName(dto.getAttachmentName());
            i.setAttachmentFlag(flag);
            i.setFileSize(dto.getFileSize());
            i.setSort(j);
            Map<String,String> map = new HashMap<>();
            String workAttachment = JSON.toJSONString((i));
            String userDTOInfo = JSON.toJSONString((userDTO));
            map.put("workAttachment",workAttachment);
            map.put("userDTO",userDTOInfo);
            SpringUtil.getBean ( IWorkAttachmentApi.class ).insertWorkAttachment(map);
            j++;
        }
    }

    //保存项目基本信息
    @PostMapping(value = "saveProjectInfo")
    public void saveProjectInfo(@RequestBody RuralProjectRecordsVo ruralProjectRecordsVo){
        //获取所有的用户信息
        List<UserDTO> allUserInfo = SpringUtil.getBean(IUserApi.class).getAllUserInfo();
        if (ObjectUtils.isNotEmpty(ruralProjectRecordsVo)){
            //先进行删除
            cwProjectRecordsMapper.deleteInfoById(ruralProjectRecordsVo.getId());
            //根据报告id删除报告编号信息
            List<CwProjectReportData> reportData = cwProjectReportMapper.getByProjectId(ruralProjectRecordsVo.getId());
            for (CwProjectReportData reportDatum : reportData) {
                cwProjectInfoMapper.deleteByReportId(reportDatum.getId());
            }
            //根据项目id删除报告信息
            cwProjectReportMapper.deleteByProjectId(ruralProjectRecordsVo.getId());

            //报告
            CwProjectReport report = new CwProjectReport();
            CwProjectInfoData cwProjectInfoData = new CwProjectInfoData();

            CwProjectRecords cwProjectRecords = new CwProjectRecords();
            cwProjectRecords.setId(ruralProjectRecordsVo.getId());//项目id
            if (StringUtils.isNotBlank(ruralProjectRecordsVo.getCreateNamePhone())){
                Optional<String> matchingUserId = allUserInfo.stream()
                        .filter(user -> user.getMobile().equals(ruralProjectRecordsVo.getCreateNamePhone()))
                        .map(UserDTO::getId)
                        .findFirst();
                if (matchingUserId.isPresent()){
                    UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getById(matchingUserId.get());
                    if (userDTO != null){
                        cwProjectRecords.setCreateById(userDTO.getId());
                        cwProjectRecords.setUpdateById(userDTO.getId());
                        //归属部门
                        cwProjectRecords.setOfficeId(userDTO.getOfficeDTO().getId());
                    }
                }
            }
            cwProjectRecords.setCreateTime(ruralProjectRecordsVo.getCreateDate());
            cwProjectRecords.setProjectNumber(ruralProjectRecordsVo.getProjectId());//项目编号
            cwProjectRecords.setContractId(ruralProjectRecordsVo.getWorkContractInfo().getId());
            cwProjectRecords.setProjectName(ruralProjectRecordsVo.getProjectName());
            if (StringUtils.isNotBlank(ruralProjectRecordsVo.getProjectType())){
                if (ruralProjectRecordsVo.getProjectType().equals("2")){
                    cwProjectRecords.setProjectType("1");
                    cwProjectRecords.setReportType(ruralProjectRecordsVo.getAttachmentProjectSort()); //项目类别
                }else {
                    cwProjectRecords.setProjectType("2");
                    cwProjectRecords.setReportType(ruralProjectRecordsVo.getAttachmentProjectSort()); //项目类别
                }
            }
            cwProjectRecords.setStatus(ruralProjectRecordsVo.getProjectStatus()+"");
            cwProjectRecords.setTenantId("ccpm");
            //获取项目所在地
            List<Area> areaDTO = SpringUtil.getBean(IAreaApi.class).getAreaDTOByName(ruralProjectRecordsVo.getArea().getName());
            if (areaDTO.size()>1){
                //当出现两个相同的最后一级区域的时候去查询他们的上一级区域,然后根据上一级id进行添加
                List<Area> parentArea = SpringUtil.getBean(IAreaApi.class).getAreaDTOByName(ruralProjectRecordsVo.getCity());
                for (Area area : areaDTO) {
                    for (Area parArea : parentArea) {
                        if (area.getParentId().equals(parArea.getId())){
                            cwProjectRecords.setAreaId(area.getId());
                        }

                    }
                }
            }else {
                if (ObjectUtils.isNotEmpty(areaDTO)){
                    for (Area area : areaDTO) {
                        cwProjectRecords.setAreaId(area.getId());

                    }
                }
            }
            //项目等级
            if (StringUtils.isNotBlank(ruralProjectRecordsVo.getSubmitMoney())){
                if (ruralProjectRecordsVo.getSubmitMoney().equals("1")){
                    cwProjectRecords.setProjectLevel("2");
                }else {
                    cwProjectRecords.setProjectLevel("1");
                }
            }

            //项目金额
            if (ObjectUtils.isNotEmpty(ruralProjectRecordsVo.getTotalFees())){
                cwProjectRecords.setProjectMoney(ruralProjectRecordsVo.getTotalFees().toString());
            }
            //项目开始时间结束时间
            cwProjectRecords.setProjectStartTime(ruralProjectRecordsVo.getStartDate());
            cwProjectRecords.setProjectEndTime(ruralProjectRecordsVo.getEndDate());
            //工程类型
            cwProjectRecords.setEngineeringType(ruralProjectRecordsVo.getEngineeringType());
            //项目负责人
            if (StringUtils.isNotBlank(ruralProjectRecordsVo.getProjectMasterPhone())){
                Optional<String> matchingUserId = allUserInfo.stream()
                        .filter(user -> user.getMobile().equals(ruralProjectRecordsVo.getProjectMasterPhone()))
                        .map(UserDTO::getId)
                        .findFirst();
                if (matchingUserId.isPresent()){
                    UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getById(matchingUserId.get());
                    if (userDTO != null){
                        cwProjectRecords.setProjectLeaderId(userDTO.getId());
                    }
                }

            }
            cwProjectRecordsMapper.insert(cwProjectRecords);
            //项目联系人
            cwProjectClientContactMapper.delete(new QueryWrapper<CwProjectClientContact>().eq("project_id",ruralProjectRecordsVo.getId()));
            if (CollectionUtils.isNotEmpty(ruralProjectRecordsVo.getWorkClientLinkmanList())){
                for (WorkClientLinkman workClientLinkman : ruralProjectRecordsVo.getWorkClientLinkmanList()) {
                    if (workClientLinkman.getClientId() != null){
                        CwProjectClientContact cwProjectClientContact = new CwProjectClientContact();
                        cwProjectClientContact.setProjectId(ruralProjectRecordsVo.getId());
                        cwProjectClientContact.setClientId(workClientLinkman.getId());
                        cwProjectClientContact.setEmail(workClientLinkman.getEmail());
                        cwProjectClientContact.setContactFirst(workClientLinkman.getLinkMobile());
                        cwProjectClientContact.setContactSecond(workClientLinkman.getLinkPhone());
                        cwProjectClientContact.setName(workClientLinkman.getName());
                        cwProjectClientContact.setPosition(workClientLinkman.getPosition());
                        if (StringUtils.isNotBlank(workClientLinkman.getOffice())){
                            OfficeDTO officeDTOByName = SpringUtil.getBean(IOfficeApi.class).getOfficeDTOByName(workClientLinkman.getOffice());
                            if (officeDTOByName != null){
                                cwProjectClientContact.setOfficeId(officeDTOByName.getId());
                            }
                        }
                        cwProjectClientContact.setClientContactId(workClientLinkman.getClientId().getId());
                        cwProjectClientContact.setTenantId("ccpm");
                        cwProjectClientContactMapper.insert(cwProjectClientContact);
                    }
                }
            }
            String id = UUID.randomUUID().toString().replace("-", "");
            //报告信息
            report.setId(id);
            report.setProjectId(ruralProjectRecordsVo.getId());
            report.setTenantId("ccpm");
//            report.setStatus("5");
            if (StringUtils.isNotBlank(ruralProjectRecordsVo.getCreateName())){
                UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(ruralProjectRecordsVo.getCreateName());
                if (userDTO != null){
                    report.setCreateById(userDTO.getId());
                    report.setUpdateById(userDTO.getId());
                }

            }
            cwProjectReportMapper.insert(report);

            //报告编号
            String id1 = UUID.randomUUID().toString().replace("-", "");
            cwProjectInfoData.setId(id1);
            cwProjectInfoData.setReportId(id);
            cwProjectInfoData.setReportNo(ruralProjectRecordsVo.getProjectReportNumber());
            cwProjectInfoData.setTenantId("ccpm");
            if (StringUtils.isNotBlank(ruralProjectRecordsVo.getCreateName())){
                UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(ruralProjectRecordsVo.getCreateName());
                if (userDTO != null){
                    cwProjectInfoData.setCreateById(userDTO.getId());
                    cwProjectInfoData.setUpdateById(userDTO.getId());
                }

            }
            cwProjectInfoMapper.insert(cwProjectInfoData);
        }
    }

    //保存质量复核信息
    @PostMapping(value = "saveProjectReview")
    public void saveProjectReview(@RequestBody RuralProjectRecordsVo recordsVo){
        //先进行删除复核信息
        cwProjectReviewNewMapper.deleteInfoById(recordsVo.getPrdId());
        //复核
        CwProjectReviewNew cwProjectReviewNew = new CwProjectReviewNew();
        //获取报告号id
        List<CwProjectReportData> projectId = cwProjectReportMapper.getByProjectId(recordsVo.getId());

        if (StringUtils.isNotBlank(recordsVo.getPrdId())) {
            //保存质量复核及报告信息
            cwProjectReviewNew.setId(recordsVo.getPrdId());
            cwProjectReviewNew.setProjectId(recordsVo.getId());
            cwProjectReviewNew.setReportId(projectId.get(0).getId());
            cwProjectReviewNew.setReviewStatus(recordsVo.getProjectReportStatus().toString());
            cwProjectReviewNew.setTenantId("ccpm");
            if (StringUtils.isNotBlank(recordsVo.getCreateName())){
                UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(recordsVo.getCreateName());
                if (userDTO != null){
                    cwProjectReviewNew.setCreateById(userDTO.getId());
                    cwProjectReviewNew.setUpdateById(userDTO.getId());
                }

            }
            cwProjectReviewNewMapper.insert(cwProjectReviewNew);
        }
    }


    //保存报告签发信息
    @PostMapping(value = "saveProjectReportTwo")
    public void saveProjectReportTwo(@RequestBody RuralProjectRecordsVo recordsVo){
        //先进行删除
        cwProjectReportSignAndIssueMapper.deleteInfoById(recordsVo.getPrdtId());
        //保存报告签发信息
        CwProjectReportSignAndIssue cwProjectReportSignAndIssue = new CwProjectReportSignAndIssue();
        cwProjectReportSignAndIssue.setId(recordsVo.getPrdtId());
        cwProjectReportSignAndIssue.setProjectId(recordsVo.getId());
        if (ObjectUtils.isNotEmpty(recordsVo.getProjectReportStatusTwo())){
            cwProjectReportSignAndIssue.setStatus(recordsVo.getProjectReportStatusTwo().toString());
        }else {
            cwProjectReportSignAndIssue.setStatus("");

        }
        cwProjectReportSignAndIssue.setTenantId("ccpm");
        if (StringUtils.isNotBlank(recordsVo.getCreateName())){
            UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(recordsVo.getCreateName());
            if (userDTO != null){
                cwProjectReportSignAndIssue.setCreateById(userDTO.getId());
                cwProjectReportSignAndIssue.setUpdateById(userDTO.getId());
            }

        }
        cwProjectReportSignAndIssueMapper.insert(cwProjectReportSignAndIssue);
    }

    //保存电子归档信息
    @PostMapping(value = "saveProjectReportOnline")
    public  void saveProjectReportOnline(@RequestBody RuralProjectRecordsVo recordsVo){
        //先进行删除
        cwProjectReportOnlineArchivingMapper.deleteInfoById(recordsVo.getPrrId());

        //根据项目id查询报告信息
        List<CwProjectReportData> reportData = cwProjectReportMapper.getByProjectId(recordsVo.getId());
        if (CollectionUtils.isNotEmpty(reportData)){
            for (CwProjectReportData reportDatum : reportData) {
                CwProjectReportOnlineArchiving cwProjectReportOnlineArchiving = new CwProjectReportOnlineArchiving();
                cwProjectReportOnlineArchiving.setId(recordsVo.getPrrId());
                cwProjectReportOnlineArchiving.setReportId(reportDatum.getId());
                if (ObjectUtils.isNotEmpty(recordsVo.getProjectReportRecordStatus())){
                    cwProjectReportOnlineArchiving.setStatus(recordsVo.getProjectReportRecordStatus().toString());
                }else {
                    cwProjectReportOnlineArchiving.setStatus("");
                }
                cwProjectReportOnlineArchiving.setTenantId("ccpm");
                if (StringUtils.isNotBlank(recordsVo.getCreateName())){
                    UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(recordsVo.getCreateName());
                    if (userDTO != null){
                        cwProjectReportOnlineArchiving.setCreateById(userDTO.getId());
                        cwProjectReportOnlineArchiving.setUpdateById(userDTO.getId());
                    }

                }
                cwProjectReportOnlineArchivingMapper.insert(cwProjectReportOnlineArchiving);
             }
        }
    }

    //保存纸质归档信息
    @PostMapping(value = "saveProjectReportPaper")
    public  void saveProjectReportPaper(@RequestBody RuralProjectRecordsVo recordsVo){
        //先进行删除
        cwProjectReportPaperArchivingMapper.deleteInfoById(recordsVo.getPrrdId());

        //根据项目id查询报告信息
        List<CwProjectReportData> reportData = cwProjectReportMapper.getByProjectId(recordsVo.getId());
        if (CollectionUtils.isNotEmpty(reportData)){
            for (CwProjectReportData reportDatum : reportData) {
                CwProjectReportPaperArchiving cwProjectReportPaperArchiving = new CwProjectReportPaperArchiving();
                cwProjectReportPaperArchiving.setId(recordsVo.getPrrdId());
                cwProjectReportPaperArchiving.setReportId(reportDatum.getId());
                if (ObjectUtils.isNotEmpty(recordsVo.getDownProjectReportRecordStatus())){
                    cwProjectReportPaperArchiving.setStatus(recordsVo.getDownProjectReportRecordStatus().toString());
                }else{
                    cwProjectReportPaperArchiving.setStatus("");
                }
                cwProjectReportPaperArchiving.setTenantId("ccpm");
                if (StringUtils.isNotBlank(recordsVo.getCreateName())){
                    UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(recordsVo.getCreateName());
                    if (userDTO != null){
                        cwProjectReportPaperArchiving.setCreateById(userDTO.getId());
                        cwProjectReportPaperArchiving.setUpdateById(userDTO.getId());
                    }

                }
                cwProjectReportPaperArchivingMapper.insert(cwProjectReportPaperArchiving);
            }
        }
    }



}
