/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.finance.ccpm.vo;



import com.jeeplus.core.domain.BaseEntity;

import com.jeeplus.sys.service.dto.UserDTO;
import com.jeeplus.sys.service.dto.WorkAttachmentInfoDTO;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 报告详情Entity
 * @author yangfan
 * @version 2018-06-05
 */
@Data
public class ProjectReportDataVo extends BaseEntity {

	private static final long serialVersionUID = 1L;
	private String companyId;		// 公司id
	private String officeId;		// 部门id
	private String officeName;		// 部门id

	private String name;		// 报告名称
	private String number;		// 报告编号
	private String type;		// 工作内容类型
	private String achievementType;		// 成果类型
	private String reviewStandard;		// 复核标准
	private UserDTO signCostOne;		// 签字造价师一
	private UserDTO signCostTwo;		// 签字造价师二
	private UserDTO master;		// 负责人
	private Date reportDate;		// 报告日期
	private String fileStatus;		// 归档状态
	private String downFileStatus;		// 归档状态
	private String status;		// 报告状态 1待归档 2已归档
	private String invalidStatus;		// 报告作废状态
	private Date startDate;
	private Date endDate;
	private List<WorkAttachmentInfoDTO> workAttachments;
	private String processInstanceId; // 流程实例编号
	private String invalidProcessInstanceId; // 流程实例编号
	private String home;
	private String reportId;
	private String numberPath;
	private String tempType;    //模板类型
	private String bzshbUserId; //总审用户id
	private String ZiXunShouRu;	//造价咨询营业收入（万元）
	private String ziXunShou;	//造价咨询营业收入

	private Integer beforeCount;
	private String clientName;
	private String contractNum;
	private String contractName;
	private String projectMaster;
	private String projectMasterId;
	private Date createStartDate;
	private Date createEndDate;
	private Date createDate;
	private Date updateDate;
	private String typeName;
	private String projectName;
	private String projectNum;
	private String signCostOneName;
	private String signCostTwoName;
	private String masterName;
	private String upId;


	private String reviewFee;  //送审价
	private String approvalFee;  //审定价
	private String contractFee;   //合同价
	private String verifyFee;    //核增核减额
	private String verifyRate;    //核增核减率
	private String buildingRate;    //土建比例
	private String installRate;    //安装比例
	private String consultFee;    //咨询标的额
	private String buildingFee;   //土建额
	private String installFee;    //安装额
	private String recordNum;     //归档申请编号
	private String templateTypeName;
	private String conditionType;   //判断条件
	private Date auditPassDate;   //审核通过日期
	private UserDTO consultant;		// 专业咨询员
	private String consultantRemarks;  //咨询员意见
	private Date consultantDate;  //咨询员审核时间
	private UserDTO principal;		// 项目负责人
	private String principalRemarks;  //项目负责人意见
	private Date principalDate;  //项目负责人审核时间
	private UserDTO technicist;		// 项目技术员
	private String technicistRemarks;  //项目技术员意见
	private Date technicistDate;  //项目技术员审核时间

	private String contractCategory;	//报告合同类别
	private String contractRate;	//合同费率

	private String examinScore;		//抽查总分
	private Integer signatureFlag;		//是否审定单签章(1为已签章)
	private String signatureDocumentId;		//签章documentid
	private String signatureContractId;		//签章contractid
	private String signatureUrl;		//审定单签章文件路径
	private Integer signatureUrlFlag;		//审定单签章文件路径(判定条件)
	private String signatureInvalidDocumentId;		//无效的签章documentid
	private String signatureFileName;		//签章文件名称
	private UserDTO signatureUploadFileUser;		//签章文件上传人信息
	private Date signatureUploadDate;		//签章文件上传时间
	private Date firstAuditDate;  //质量复核初次审核时间
	private String overReportStatus;  //是否超期
	private String createName;
	private List<RuralReportConsultant> consultants;

	}
