package com.xxl.job.executor.feign;

import com.jeeplus.common.constant.AppNameConstants;
import com.jeeplus.flowable.feign.IFinanceApi;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;

/**
 * @author: 王强
 * @create: 2023-07-27 08:48
 **/
@FeignClient(contextId = "financeFeignApi", name = AppNameConstants.APP_FINANCE_MODULES)
public interface FinanceFeignApi extends IFinanceApi {

    /**
     * 查询开票时间距今超过1个月的开票数据
     */
    @GetMapping(value = "/cw_finance/invoice/getExceedCwFinance")
    String getExceedCwFinance();
}
